@online{smartesting,
  title = {Smartesting},
  year = 2024,
  url = {https://www.smartesting.com/en/},
  urldate = {2024-05-04}
}

@online{pex_by_msc,
   title = {Generation Test - Automated Unit Tests for Legacy Code with Pex},
   year = {2009},
   url = {https://learn.microsoft.com/en-us/archive/msdn-magazine/2009/december/generation-test-automated-unit-tests-for-legacy-code-with-pex},
   urldate = {2024-05-11}
}

@article{pynguin,
  author       = {Stephan Lukasczyk and
                  Florian Kroi{\ss} and
                  Gordon Fraser},
  title        = {Automated Unit Test Generation for Python},
  journal      = {CoRR},
  volume       = {abs/2007.14049},
  year         = {2020},
  url          = {https://arxiv.org/abs/2007.14049},
  eprinttype    = {arXiv},
  eprint       = {2007.14049},
  timestamp    = {Sat, 23 Jan 2021 01:11:32 +0100},
  biburl       = {https://dblp.org/rec/journals/corr/abs-2007-14049.bib},
  bibsource    = {dblp computer science bibliography, https://dblp.org}
}

@inbook{mio,
   title={Many Independent Objective (MIO) Algorithm for Test Suite Generation},
   ISBN={9783319662992},
   ISSN={1611-3349},
   url={http://dx.doi.org/10.1007/978-3-319-66299-2_1},
   DOI={10.1007/978-3-319-66299-2_1},
   booktitle={Lecture Notes in Computer Science},
   publisher={Springer International Publishing},
   author={Arcuri, Andrea},
   year={2017},
   pages={3–17}
}

@inproceedings{cute,
author = {Sen, Koushik and Marinov, Darko and Agha, Gul},
title = {CUTE: a concolic unit testing engine for C},
year = {2005},
isbn = {1595930140},
publisher = {Association for Computing Machinery},
address = {New York, NY, USA},
url = {https://doi.org/10.1145/1081706.1081750},
doi = {10.1145/1081706.1081750},
abstract = {In unit testing, a program is decomposed into units which are collections of functions. A part of unit can be tested by generating inputs for a single entry function. The entry function may contain pointer arguments, in which case the inputs to the unit are memory graphs. The paper addresses the problem of automating unit testing with memory graphs as inputs. The approach used builds on previous work combining symbolic and concrete execution, and more specifically, using such a combination to generate test inputs to explore all feasible execution paths. The current work develops a method to represent and track constraints that capture the behavior of a symbolic execution of a unit with memory graphs as inputs. Moreover, an efficient constraint solver is proposed to facilitate incremental generation of such test inputs. Finally, CUTE, a tool implementing the method is described together with the results of applying CUTE to real-world examples of C code.},
booktitle = {Proceedings of the 10th European Software Engineering Conference Held Jointly with 13th ACM SIGSOFT International Symposium on Foundations of Software Engineering},
pages = {263–272},
numpages = {10},
keywords = {unit testing, testing C programs, random testing, explicit path model-checking, data structure testing, concolic testing},
location = {Lisbon, Portugal},
series = {ESEC/FSE-13}
}

@InProceedings{pex,
author="Tillmann, Nikolai
and de Halleux, Jonathan",
editor="Beckert, Bernhard
and H{\"a}hnle, Reiner",
title="Pex--White Box Test Generation for .NET",
booktitle="Tests and Proofs",
year="2008",
publisher="Springer Berlin Heidelberg",
address="Berlin, Heidelberg",
pages="134--153",
abstract="Pex automatically produces a small test suite with high code coverage for a .NET program. To this end, Pex performs a systematic program analysis (using dynamic symbolic execution, similar to path-bounded model-checking) to determine test inputs for Parameterized Unit Tests. Pex learns the program behavior by monitoring execution traces. Pex uses a constraint solver to produce new test inputs which exercise different program behavior. The result is an automatically generated small test suite which often achieves high code coverage. In one case study, we applied Pex to a core component of the .NET runtime which had already been extensively tested over several years. Pex found errors, including a serious issue.",
isbn="978-3-540-79124-9"
}

@online{chatgpt,
   title = {ChatGPT},
   year = {2022},
   url = {https://fr.wikipedia.org/wiki/ChatGPT},
   urldate = {2024-05-12}
}

@online{github_copilot_tests,
	title = {Accelerate test-driven development with AI},
	year = {2023},
	url = {https://github.com/readme/guides/github-copilot-automattic},
	urldate = {2024-05-13}
}

@online{github_copilot,
	title = {Github Copilot},
	year = {2022},
	url = {https://github.com/features/copilot},
	urldate = {2024-05-13}
}
@online{jetbrain_ai,
	title = {JetBrains AI},
    url = {https://www.jetbrains.com/ai/},
    urldate = {2024-05-17}
}

@online{openai_codex,
	title = {OpenAI Codes},
	year = {2023},
	url = {https://openai.com/index/openai-codex/},
	urldate = {2024-05-13}
}

@article{mbpp,
  title={Program Synthesis with Large Language Models},
  author={Austin, Jacob and Odena, Augustus and Nye, Maxwell and Bosma, Maarten and Michalewski, Henryk and Dohan, David and Jiang, Ellen and Cai, Carrie and Terry, Michael and Le, Quoc and others},
  journal={arXiv preprint arXiv:2108.07732},
  year={2021}
 }

@article{umtg,
  author       = {Chunhui Wang and
                  Fabrizio Pastore and
                  Arda Goknil and
                  Lionel C. Briand},
  title        = {Automatic Generation of System Test Cases from Use Case Specifications:
                  an NLP-based Approach},
  journal      = {CoRR},
  volume       = {abs/1907.08490},
  year         = {2019},
  url          = {http://arxiv.org/abs/1907.08490},
  eprinttype    = {arXiv},
  eprint       = {1907.08490},
  timestamp    = {Tue, 23 Jul 2019 10:54:22 +0200},
  biburl       = {https://dblp.org/rec/journals/corr/abs-1907-08490.bib},
  bibsource    = {dblp computer science bibliography, https://dblp.org}
}

@misc{pynguin_chatgpt_comparison,
      title={Unit Test Generation using Generative AI : A Comparative Performance Analysis of Autogeneration Tools}, 
      author={Shreya Bhatia and Tarushi Gandhi and Dhruv Kumar and Pankaj Jalote},
      year={2024},
      eprint={2312.10622},
      archivePrefix={arXiv},
      primaryClass={cs.SE}
}
